﻿
Imports System.Xml
Imports System.Data
Imports Microsoft.Office.Interop
Imports Microsoft.Office.Interop.Word


Public Class XML2Word
    Public Function ReadElementValue(ByVal toElement As XElement, ByVal tcKey1 As String, ByVal tcKey2 As String) As String
        Dim toEl As XElement
        Try
            toEl = toElement.Element(tcKey1)
            If toEl Is Nothing Then
                ReadElementValue = ""
                Exit Function
            End If

            If String.IsNullOrEmpty(tcKey2) Then
                ReadElementValue = toEl.Value
            Else
                ReadElementValue = toEl.Element(tcKey2).Value
            End If

        Catch ex As Exception
            ReadElementValue = ""
        End Try
    End Function

    Public Sub ReadData(ByRef tcFile As String, _
                        ByRef toPrj As AsbestProject, _
                        ByRef toPrjMon As Collection, _
                        ByRef toBE As Collection, _
                        ByRef toAHMat As Collection, _
                        ByRef toAHLoc As Collection, _
                        ByRef toNietAhBron As Collection, _
                        ByRef toPrjDocs As Collection)

        ' leest de XML file in en plaatst deze in de objecten welke als parameters zijn opgegeven
        ' Alle enumeratie teksten definieren
        Dim oEnumteksten As New EnumTeksten

        Dim aAARD_MATERIAAL As New Dictionary(Of String, String)
        Dim aASBEST_ADVIES As New Dictionary(Of String, String)
        Dim aASBEST_CONDITIE As New Dictionary(Of String, String)
        Dim aASBEST_EENHEID As New Dictionary(Of String, String)
        Dim aASBEST_EENHEID_VOLUME As New Dictionary(Of String, String)
        Dim aASBEST_HOEVEELHEID As New Dictionary(Of String, String)
        Dim aASBEST_MAATREGEL As New Dictionary(Of String, String)
        Dim aASBEST_VERWIJDERING_KEUZE As New Dictionary(Of String, String)
        Dim aASBEST_VERWIJDERING_METHODE As New Dictionary(Of String, String)
        Dim aASBESTHOUDEND As New Dictionary(Of String, String)
        Dim aDOCUMENT As New Dictionary(Of String, String)
        Dim aINVENTARISATIE As New Dictionary(Of String, String)
        Dim aLOCATIE As New Dictionary(Of String, String)
        Dim aMELDING As New Dictionary(Of String, String)
        Dim aONDERZOEK As New Dictionary(Of String, String)
        Dim aNEN2991ONDERZOEK As New Dictionary(Of String, String)
        Dim aONDERZOEK_BEVESTIGINGS_METHODE As New Dictionary(Of String, String)
        Dim aOPDRACHT_TYPE As New Dictionary(Of String, String)
        Dim aPERCENTAGE As New Dictionary(Of String, String)
        Dim aSMA_RISICO_KLASSE As New Dictionary(Of String, String)
        Dim aTITEL As New Dictionary(Of String, String)
        Dim aVERVOLG_ONDERZOEKS_KEUZE As New Dictionary(Of String, String)
        Dim aVERWIJDERING_RESULTAAT As New Dictionary(Of String, String)
        Dim aVEZELS_INDICATOR As New Dictionary(Of String, String)

        oEnumteksten.Enum_AARD_MATERIAAL(aAARD_MATERIAAL)
        oEnumteksten.Enum_ASBEST_ADVIES(aASBEST_ADVIES)
        oEnumteksten.Enum_ASBEST_CONDITIE(aASBEST_CONDITIE)
        oEnumteksten.Enum_ASBEST_EENHEID(aASBEST_EENHEID)
        oEnumteksten.Enum_ASBEST_EENHEID_VOLUME(aASBEST_EENHEID_VOLUME)
        oEnumteksten.Enum_ASBEST_HOEVEELHEID(aASBEST_HOEVEELHEID)
        oEnumteksten.Enum_ASBEST_MAATREGEL(aASBEST_MAATREGEL)
        oEnumteksten.Enum_ASBEST_VERWIJDERING_KEUZE(aASBEST_VERWIJDERING_KEUZE)
        oEnumteksten.Enum_ASBEST_VERWIJDERING_METHODE(aASBEST_VERWIJDERING_METHODE)
        oEnumteksten.Enum_ASBESTHOUDEND(aASBESTHOUDEND)
        oEnumteksten.Enum_DOCUMENT(aDOCUMENT)
        oEnumteksten.Enum_INVENTARISATIE(aINVENTARISATIE)
        oEnumteksten.Enum_LOCATIE(aLOCATIE)
        oEnumteksten.Enum_MELDING(aMELDING)
        oEnumteksten.Enum_ONDERZOEK(aONDERZOEK)
        oEnumteksten.Enum_NEN2991ONDERZOEK(aNEN2991ONDERZOEK)
        oEnumteksten.Enum_ONDERZOEK_BEVESTIGINGS_METHODE(aONDERZOEK_BEVESTIGINGS_METHODE)
        oEnumteksten.Enum_OPDRACHT_TYPE(aOPDRACHT_TYPE)
        oEnumteksten.Enum_PERCENTAGE(aPERCENTAGE)
        oEnumteksten.Enum_SMA_RISICO_KLASSE(aSMA_RISICO_KLASSE)
        oEnumteksten.Enum_TITEL(aTITEL)
        oEnumteksten.Enum_VERVOLG_ONDERZOEKS_KEUZE(aVERVOLG_ONDERZOEKS_KEUZE)
        oEnumteksten.Enum_VERWIJDERING_RESULTAAT(aVERWIJDERING_RESULTAAT)
        oEnumteksten.Enum_VEZELS_INDICATOR(aVEZELS_INDICATOR)

        Dim x As String = ""
        Dim cDatum As String

        'De dataobjecten gaan voorzien van projectgegevens
        Dim LAVSPrj As XElement = XElement.Load(tcFile)

        ' de project gegevevens
        toPrj.PRJ_LAVSNR = LAVSPrj.Element("id").Value
        toPrj.PRJ_LOCTYPE = aLOCATIE(LAVSPrj.Element("locatie").Element("type").Element("naam").Value)
        toPrj.PRJ_LOCADRES = LAVSPrj.Element("locatie").Element("adres").Element("straat").Value & " " & LAVSPrj.Element("locatie").Element("adres").Element("huisnummer").Value
        toPrj.PRJ_LOCPLAATS = LAVSPrj.Element("locatie").Element("adres").Element("plaats").Value

        ' de meest recente melding gaan seleceteren
        ' dit bepaalt ook meteen de inventarisatie
        Dim recentemeldingen = _
            (From melding In LAVSPrj.Elements("inventarisaties").Elements("meldingen") _
           Order By melding.Element("datumGemeld").Value Descending _
         Select melding, _
            Start = melding.Element("start").Value, _
            Eind = melding.Element("eind").Value, _
            InvID = melding.Parent.Element("id").Value)


        If recentemeldingen.Count = 0 Then
            ' geen recentemelding kunnen bepalen
            ' lege data aan alle objecten hangen
            toPrj.PRJ_START_DDMMYY = ""
            toPrj.PRJ_START_DDMMYY = ""
            toPrj.PRJ_NEN2991 = ""

            toBE.Add(New BouwkundigeEenheid("", ""))
            toAHMat.Add(New AsbesthoudendeMateriaal("", "", "", "", "", "", "", ""))
            toAHLoc.Add(New LocatieAhBron("", "", "", "", "", "", ""))
            toNietAhBron.Add(New NietAhBron("", "", "", "", "", "", "", ""))
            toPrjDocs.Add(New AsbestDocument("", ""))
            toPrjMon.Add(New Monster("", "", "", "", ""))

        Else
            Dim recentemelding = recentemeldingen.First
            '; de datum velden voor de melding gaat zetten
            cDatum = CType(recentemelding.Start, DateTime).ToString("ddMMyyyy")
            toPrj.PRJ_START_DDMMYY = cDatum.Substring(0, 2) & "/" & cDatum.Substring(2, 2) & "/" & cDatum.Substring(4, 4)
            cDatum = CType(recentemelding.Eind, DateTime).ToString("ddMMyyyy")
            toPrj.PRJ_START_DDMMYY = cDatum.Substring(0, 2) & "/" & cDatum.Substring(2, 2) & "/" & cDatum.Substring(4, 4)

            Dim prjInv = _
                (From inv In LAVSPrj.Elements("inventarisaties") _
                Select inv Where inv.Element("id") = recentemelding.InvID) _
            .First()

            toPrj.PRJ_NEN2991 = prjInv.Element("nen2991").Value

            ' de bouwkundige eenheden gaan selecteren
            Dim prjBEs = _
                From plaatsaanduiding In LAVSPrj.Elements("plaatsAanduidingen") _
                 Select plaatsaanduiding

            Dim loBE As BouwkundigeEenheid = Nothing
            If prjBEs.Count = 0 Then
                toBE.Add(New BouwkundigeEenheid("", ""))
            Else
                For Each prjBE In prjBEs
                    loBE = New BouwkundigeEenheid(ReadElementValue(prjBE, "elementen", ""), "")
                    toBE.Add(loBE)
                Next
            End If

            ' De Asbesthoudende materialen gaan selecteren
            Dim prjAHMats = _
                    From brontype In prjInv.Elements("bronnen").Elements("brontype") _
                    Where (brontype.Element("asbesthoudend").Element("naam") = "JA" Or brontype.Element("asbesthoudend").Element("naam") = "VERDACHT") _
                    Select brontype

            Dim loAHMat As AsbesthoudendeMateriaal = Nothing

            ' eigenschappen voor de asbesthoudende materialen
            Dim lcAhMatNaam As String = ""
            Dim lcAhNaam As String = ""
            Dim lcAhAardMateriaal As String = ""
            Dim lcAhOndBevMethode As String = ""
            Dim lcAhAsbestVerwMethode As String = ""
            Dim lcAhSMARisicoKlasse As String = ""
            Dim lcAhAsbestMaatregel As String = ""
            Dim lcAhToelichting As String = ""

            If prjAHMats.Count = 0 Then
                toAHMat.Add(New AsbesthoudendeMateriaal("", "", "", "", "", "", "", ""))
            Else
                For Each prjAHMat In prjAHMats
                    Try
                        lcAhMatNaam = ReadElementValue(prjAHMat, "naam", "")
                    Catch
                        lcAhMatNaam = ""
                    End Try

                    Try
                        lcAhNaam = aASBESTHOUDEND(ReadElementValue(prjAHMat, "asbesthoudend", "naam"))
                    Catch
                        lcAhNaam = ""
                    End Try

                    Try
                        lcAhAardMateriaal = aAARD_MATERIAAL(ReadElementValue(prjAHMat, "aardMateriaal", "naam"))
                    Catch
                        lcAhAardMateriaal = ""
                    End Try

                    Try
                        lcAhOndBevMethode = aONDERZOEK_BEVESTIGINGS_METHODE(ReadElementValue(prjAHMat, "bevestigingsmethode", "naam"))
                    Catch
                        lcAhOndBevMethode = ""
                    End Try

                    Try
                        lcAhAsbestVerwMethode = aASBEST_VERWIJDERING_METHODE(ReadElementValue(prjAHMat, "verwijderingsMethode", "naam"))
                    Catch
                        lcAhAsbestVerwMethode = ""
                    End Try

                    Try
                        lcAhSMARisicoKlasse = aSMA_RISICO_KLASSE(ReadElementValue(prjAHMat, "smaRisicoKlasse", "naam"))
                    Catch
                        lcAhSMARisicoKlasse = ""
                    End Try

                    Try
                        lcAhAsbestMaatregel = aASBEST_MAATREGEL(ReadElementValue(prjAHMat, "aanbevolenMaatregel", "naam"))
                    Catch
                        lcAhAsbestMaatregel = ""
                    End Try

                    lcAhToelichting = ""

                    loAHMat = New AsbesthoudendeMateriaal( _
                            lcAhMatNaam, _
                            lcAhNaam, _
                            lcAhAardMateriaal, _
                            lcAhOndBevMethode, _
                            lcAhAsbestVerwMethode, _
                            lcAhSMARisicoKlasse, _
                            lcAhAsbestMaatregel, _
                            lcAhToelichting)
                    toAHMat.Add(loAHMat)
                Next
            End If

            'Asbesthouden locaties
            ' Dit zijn alle bronnen van de bronnen welke in prjAHMats zijn geselecteerd
            ' eigenschappen voor de asbesthoudende locaties
            Dim loAHLoc As LocatieAhBron = Nothing

            Dim lcAhLocType As String = ""
            Dim lcAhLocNaam As String = ""
            Dim lcAhLocBE As String = ""
            Dim lcAhLocConditie As String = ""
            Dim lcAhLocAantal As String = ""
            Dim lcAhLocHoeveelheid As String = ""
            Dim lcAhLocToelichting As String = ""

            Dim prjAHLocs = _
                    From bron In prjInv.Elements("bronnen") _
                    Where (bron.Element("brontype").Element("asbesthoudend").Element("naam") = "JA" Or _
                           bron.Element("brontype").Element("asbesthoudend").Element("naam") = "VERDACHT" Or _
                           bron.Element("brontype").Element("asbesthoudend").Element("naam") = "JA_INTECHNIUM") _
                    Select bron

            If prjAHLocs.Count = 0 Then
                toAHLoc.Add(New LocatieAhBron("", "", "", "", "", "", ""))
            Else
                For Each prjAHLoc In prjAHLocs
                    Try
                        lcAhLocType = ReadElementValue(prjAHLoc, "brontype", "naam")
                    Catch
                        lcAhLocType = ""
                    End Try
                    Try
                        lcAhLocNaam = prjAHLoc.Element("bron").Value
                    Catch
                        lcAhLocNaam = ""
                    End Try
                    Try
                        lcAhLocBE = prjAHLoc.Element("plaats").Element("plaatsAanduiding").Element("elementenAsString").Value
                    Catch
                        lcAhLocBE = ""
                    End Try
                    Try
                        lcAhLocConditie = aASBEST_CONDITIE(prjAHLoc.Element("conclusie").Element("conditie").Element("naam").Value)
                    Catch
                        lcAhLocConditie = ""
                    End Try
                    Try
                        lcAhLocAantal = prjAHLoc.Element("plaats").Element("hoeveelheid").Element("aantal").Value
                    Catch
                        lcAhLocAantal = ""
                    End Try

                    Try
                        lcAhLocHoeveelheid = prjAHLoc.Element("plaats").Element("hoeveelheid").Element("afmeting").Value & " " & _
                                aASBEST_EENHEID(prjAHLoc.Element("plaats").Element("hoeveelheid").Element("eenheidType").Element("naam").Value)
                    Catch
                        lcAhLocHoeveelheid = ""
                    End Try

                    loAHLoc = New LocatieAhBron(lcAhLocType, lcAhLocNaam, lcAhLocBE, lcAhLocConditie, lcAhLocAantal, lcAhLocHoeveelheid, lcAhLocToelichting)
                    toAHLoc.Add(loAHLoc)
                Next
            End If

            ' NIET asbesthoudende bronnen 
            Dim prjNietAHBronnen = _
            From brontype In prjInv.Elements("bronnen").Elements("brontype") _
            Where (brontype.Element("asbesthoudend").Element("naam") = "NEE") _
            Select brontype

            Dim loNietAHBron As NietAhBron = Nothing

            ' eigenschappen voor de asbesthoudende materialen
            Dim lcNietAhBronType As String = ""
            Dim lcNietAhBronNaam As String = ""
            Dim lcNietAhBronAardMateriaal As String = ""
            Dim lcNietAhBronOndBevMethode As String = ""
            Dim lcNietAhBronAsbestVerwMethode As String = ""
            Dim lcNietAhBronSMARisicoKlasse As String = ""
            Dim lcNietAhBronAsbestMaatregel As String = ""
            Dim lcNietAhBronToelichting As String = ""

            If prjNietAHBronnen.Count = 0 Then
                toNietAhBron.Add(New NietAhBron("", "", "", "", "", "", "", ""))
            Else
                For Each prjNietAHBron In prjNietAHBronnen
                    Try
                        lcNietAhBronType = prjNietAHBron.Element("naam").Value
                    Catch
                        lcNietAhBronType = ""
                    End Try

                    Try
                        lcNietAhBronNaam = aASBESTHOUDEND(prjNietAHBron.Element("asbesthoudend").Element("naam").Value)
                    Catch
                        lcNietAhBronNaam = ""
                    End Try

                    Try
                        lcNietAhBronAardMateriaal = aAARD_MATERIAAL(prjNietAHBron.Element("aardMateriaal").Element("naam").Value)
                    Catch
                        lcNietAhBronAardMateriaal = ""
                    End Try

                    Try
                        lcNietAhBronOndBevMethode = aONDERZOEK_BEVESTIGINGS_METHODE(prjNietAHBron.Element("bevestigingsmethode").Element("naam").Value)
                    Catch
                        lcNietAhBronOndBevMethode = ""
                    End Try

                    Try
                        lcNietAhBronAsbestVerwMethode = aASBEST_VERWIJDERING_METHODE(prjNietAHBron.Element("verwijderingsMethode").Element("naam").Value)
                    Catch
                        lcNietAhBronAsbestVerwMethode = ""
                    End Try

                    Try
                        lcNietAhBronSMARisicoKlasse = aSMA_RISICO_KLASSE(prjNietAHBron.Element("smaRisicoKlasse").Element("naam").Value)
                    Catch
                        lcNietAhBronSMARisicoKlasse = ""
                    End Try

                    Try
                        lcNietAhBronAsbestMaatregel = aASBEST_MAATREGEL(prjNietAHBron.Element("aanbevolenMaatregel").Element("naam").Value)
                    Catch
                        lcNietAhBronAsbestMaatregel = ""
                    End Try

                    lcAhToelichting = ""

                    loNietAHBron = New NietAhBron( _
                         lcNietAhBronType, _
                         lcNietAhBronNaam, _
                         lcNietAhBronAardMateriaal, _
                         lcNietAhBronOndBevMethode, _
                         lcNietAhBronAsbestVerwMethode, _
                         lcNietAhBronSMARisicoKlasse, _
                         lcNietAhBronAsbestMaatregel, _
                         lcNietAhBronToelichting)
                    toNietAhBron.Add(loNietAHBron)
                Next
            End If

            ' de documenten van het project verzamelen
            ' NIET asbesthoudende bronnen 
            Dim prjbijlages = _
                  From bijlage In LAVSPrj.Elements("bijlages") _
                 Select bijlage

            Dim lcDocType As String = ""
            Dim lcDocNaam As String = ""

            Dim loDoc As AsbestDocument

            If prjbijlages.Count = 0 Then
                toPrjDocs.Add(New AsbestDocument("", ""))
            Else
                For Each lobijlage As XElement In prjbijlages
                    ' x = x & "Bedrijf: " & xEle.Element("bedrijf").Value & vbNewLine
                    ' x = x & "Bestandsnaam: " & xEle.Element("bestandsNaam").Value & vbNewLine
                    ' x = x & "Id: " & xEle.Element("id").Value & vbNewLine
                    ' x = x & "Documenttype: " & aDOCUMENT(xEle.Element("documentType").Element("naam").Value) & vbNewLine

                    Try
                        lcDocType = aDOCUMENT(lobijlage.Element("documentType").Element("naam").Value)
                    Catch ex As Exception
                        lcDocType = ""
                    End Try

                    Try
                        lcDocNaam = lobijlage.Element("bestandsNaam").Value
                    Catch ex As Exception
                        lcDocNaam = ""
                    End Try

                    loDoc = New AsbestDocument( _
                        lcDocType, _
                        lcDocNaam)

                    toPrjDocs.Add(loDoc)

                Next lobijlage
            End If


            Dim prjMons = _
                From monster In prjInv.Elements("monsterZaak").Elements("monsters") _
                Select monster

            Dim loMon As Monster = Nothing

            Dim lcMonCode As String = ""
            Dim lcMonBron As String = ""
            Dim lcMonPercAsbest As String = ""
            Dim lcMonToelichting As String = ""
            Dim lcMonLabAnaNr As String = ""
            Dim lcPerc As String = ""      'hulpvar

            If prjMons.Count = 0 Then
                toPrjMon.Add(New Monster("", "", "", "", ""))
            Else

                For Each prjMon In prjMons

                    Try
                        lcMonCode = prjMon.Element("code").Value
                    Catch ex As Exception
                        lcMonCode = ""
                    End Try

                    Try
                        lcMonBron = prjMon.Element("bron").Element("bron").Value
                    Catch ex As Exception
                        lcMonBron = ""
                    End Try
                    ' Actinoliet
                    Try
                        lcPerc = prjMon.Element("actinoliet").Value
                        If lcPerc = "GEEN_ASBEST" Then
                            lcPerc = ""
                        Else
                            ' er is een waarde aangegeven
                            ' Het percentage van de asbestsoort  gaan vermelden
                            lcPerc = aPERCENTAGE(lcPerc)
                        End If
                    Catch ex As Exception
                        lcPerc = ""
                    End Try
                    If Not String.IsNullOrEmpty(lcPerc) Then
                        If Not String.IsNullOrEmpty(lcMonPercAsbest) Then
                            lcMonPercAsbest = lcMonPercAsbest & vbNewLine
                        End If
                        lcMonPercAsbest = lcMonPercAsbest & "Actinoliet " & lcPerc
                    End If
                    ' amosiet
                    Try
                        lcPerc = prjMon.Element("amosiet").Value
                        If lcPerc = "GEEN_ASBEST" Then
                            lcPerc = ""
                        Else                    ' er is een waarde aangegeven
                            ' Het percentage van de asbestsoort  gaan vermelden
                            lcPerc = aPERCENTAGE(lcPerc)
                        End If
                    Catch ex As Exception
                        lcPerc = ""
                    End Try
                    If Not String.IsNullOrEmpty(lcPerc) Then
                        If Not String.IsNullOrEmpty(lcMonPercAsbest) Then
                            lcMonPercAsbest = lcMonPercAsbest & vbNewLine
                        End If
                        lcMonPercAsbest = lcMonPercAsbest & "Amosiet " & lcPerc
                    End If
                    'anthophylliet
                    Try
                        lcPerc = prjMon.Element("anthophylliet").Value
                        If lcPerc = "GEEN_ASBEST" Then
                            lcPerc = ""
                        Else                   ' er is een waarde aangegeven
                            ' Het percentage van de asbestsoort  gaan vermelden
                            lcPerc = aPERCENTAGE(lcPerc)
                        End If
                    Catch ex As Exception
                        lcPerc = ""
                    End Try
                    If Not String.IsNullOrEmpty(lcPerc) Then
                        If Not String.IsNullOrEmpty(lcMonPercAsbest) Then
                            lcMonPercAsbest = lcMonPercAsbest & vbNewLine
                        End If
                        lcMonPercAsbest = lcMonPercAsbest & "Anthophylliet " & lcPerc
                    End If
                    'chrysotiel
                    Try
                        lcPerc = prjMon.Element("chrysotiel").Value
                        If lcPerc = "GEEN_ASBEST" Then
                            lcPerc = ""
                        Else                    ' er is een waarde aangegeven
                            ' Het percentage van de asbestsoort  gaan vermelden
                            lcPerc = aPERCENTAGE(lcPerc)
                        End If
                    Catch ex As Exception
                        lcPerc = ""
                    End Try
                    If Not String.IsNullOrEmpty(lcPerc) Then
                        If Not String.IsNullOrEmpty(lcMonPercAsbest) Then
                            lcMonPercAsbest = lcMonPercAsbest & vbNewLine
                        End If
                        lcMonPercAsbest = lcMonPercAsbest & "Chrysotiel " & lcPerc
                    End If
                    ' crocidoliet
                    Try
                        lcPerc = prjMon.Element("crocidoliet").Value
                        If lcPerc = "GEEN_ASBEST" Then
                            lcPerc = ""
                        Else                    ' er is een waarde aangegeven
                            ' Het percentage van de asbestsoort  gaan vermelden
                            lcPerc = aPERCENTAGE(lcPerc)
                        End If
                    Catch ex As Exception
                        lcPerc = ""
                    End Try
                    If Not String.IsNullOrEmpty(lcPerc) Then
                        If Not String.IsNullOrEmpty(lcMonPercAsbest) Then
                            lcMonPercAsbest = lcMonPercAsbest & vbNewLine
                        End If
                        lcMonPercAsbest = lcMonPercAsbest & "Crocidoliet " & lcPerc
                    End If
                    ' tremoliet
                    Try
                        lcPerc = prjMon.Element("tremoliet").Value
                        If lcPerc = "GEEN_ASBEST" Then
                            lcPerc = ""
                        Else                   ' er is een waarde aangegeven
                            ' Het percentage van de asbestsoort  gaan vermelden
                            lcPerc = aPERCENTAGE(lcPerc)
                        End If
                    Catch ex As Exception
                        lcPerc = ""
                    End Try
                    If Not String.IsNullOrEmpty(lcPerc) Then
                        If Not String.IsNullOrEmpty(lcMonPercAsbest) Then
                            lcMonPercAsbest = lcMonPercAsbest & vbNewLine
                        End If
                        lcMonPercAsbest = lcMonPercAsbest & "Tremoliet " & lcPerc
                    End If

                    loMon = New Monster( _
                        lcMonCode, _
                        lcMonBron, _
                        lcMonPercAsbest, _
                        lcMonToelichting, _
                        lcMonLabAnaNr)
                    toPrjMon.Add(loMon)
                Next
            End If

        End If
    End Sub

    Public Function ConvertXML2Word(ByVal tcXMLFile As String, ByVal tcWordTemplate As String) As Boolean

        'Abstract       Leest de inhoud van een opgegeven XML bestand in in een opgegeven Wordsjabloon
        'Parameters     tcXMLFile       de xml file welke ingelezen moet worden
        '               tcWordTemplate  het wordsjabloon waar de XML gegevens in geplaatst moeten worden
        'Return         Boolean         True indien het document succesvol opgeslagen is
        'Notes          Geen

        ' De gegevens uit de de XML lezen en deze in de juiste objecten plaatsen
        'Dim loXML2Word As New XML2Word
        Dim llSuccess As Boolean
        llSuccess = True

        Dim loProject As New AsbestProject("", "", "", "", "", "")
        Dim loPrjMons As New Collection
        Dim loBE As New Collection
        Dim loAHMat As New Collection
        Dim loAHLoc As New Collection
        Dim loNietAHBron As New Collection
        Dim loPrjDocs As New Collection

        If llSuccess Then
            ReadData(tcXMLFile, loProject, loPrjMons, loBE, loAHMat, loAHLoc, loNietAHBron, loPrjDocs)

            ' Alle data is nu in objecten ingelezen. 
            ' Nu de gegevens uit de objecten in gaan voegen in Word.
            If String.IsNullOrEmpty(loProject.PRJ_LAVSNR) Then
                ' Aanname indien er geen LAVS-nr is dan geen projectdata of monsterinformatie kunnen bepalen
                llSuccess = False
            End If

        End If

        Dim llWordStarted As Boolean
        llWordStarted = False

        If llSuccess Then
            ' ALs het goed is bevatten objecten nu de gegevens uit de XML
            ' word proberen te starten
            Dim oWord As Word.Application = Nothing
            Dim oDoc As Word.Document = Nothing

            'Start Word and open the document template.
            Try
                oWord = CreateObject("Word.Application")
                oWord.ScreenUpdating = False
                llWordStarted = True
            Catch
                llSuccess = False
            End Try

            If llSuccess Then
                Try
                    oDoc = oWord.Documents.Add(tcWordTemplate)
                Catch
                    llSuccess = False
                End Try
            End If

            If llSuccess Then
                ' Word is gestart en op basis van de template is een document gemaakt
                ' Binnen het document de verschillende tags welke ingevuld kunenn worden gaan zoeken
                Dim lnRangeEnd As Integer
                ' de projecttags vervangen
                For Each prop As System.Reflection.PropertyInfo In loProject.GetType().GetProperties()
                    If prop.CanRead Then
                        'Zoeken naar de tagnaam
                        oWord.ActiveWindow.ActivePane.View.SeekView = Word.WdSeekView.wdSeekMainDocument
                        With oWord.Selection
                            .SetRange(0, 0) ' bovenaan document
                            .Find.Text = "<#" + prop.Name + "#>"
                            .Find.MatchCase = False
                            .Find.MatchWholeWord = False
                            .Find.ClearFormatting()

                            Do While .Find.Execute()
                                ' de tag is gevonden, tekst vervangen en aan het eind van de selectie verder gaan met zoeken
                                lnRangeEnd = .Range.End
                                .Text = prop.GetValue(loProject)
                                .SetRange(lnRangeEnd, lnRangeEnd)
                            Loop
                        End With

                        ' de header doorzoeken
                        oWord.ActiveWindow.ActivePane.View.SeekView = Word.WdSeekView.wdSeekCurrentPageHeader
                        With oWord.Selection
                            .SetRange(0, 0) ' bovenaan document
                            .Find.Text = "<#" + prop.Name + "#>"
                            .Find.MatchCase = False
                            .Find.MatchWholeWord = False
                            .Find.ClearFormatting()

                            Do While .Find.Execute()
                                ' de tag is gevonden, tekst vervangen en aan het eind van de selectie verder gaan met zoeken
                                lnRangeEnd = .Range.End
                                .Text = prop.GetValue(loProject)
                                .SetRange(lnRangeEnd, lnRangeEnd)
                            Loop
                        End With


                    End If
                Next

                ' De subitems gaan verwerken
                VerwerkSubItems(loPrjMons, oWord)
                VerwerkSubItems(loBE, oWord)
                VerwerkSubItems(loAHMat, oWord)
                VerwerkSubItems(loAHLoc, oWord)
                VerwerkSubItems(loNietAHBron, oWord)
                VerwerkSubItems(loPrjDocs, oWord)
            End If

            ' document proberen op te slaan
            If llSuccess Then
                ' Word gaan openen zodat men het document kan bewerken en gaan opslaan
                'bovenaan document gaan staan
                oWord.Selection.HomeKey(WdUnits.wdStory, Nothing)
                oWord.ScreenUpdating = True
                oWord.Visible = True
            Else
                ' Er is een fout opgetreden. Word afsluiten indien deze gestart was
                If llWordStarted Then
                    oWord.Quit(False)
                End If
            End If

        End If

        ConvertXML2Word = llSuccess

    End Function



    Private Sub VerwerkSubItems(ByVal toSubItems As Collection, ByRef toWord As Word.Application)
        Dim lnRangeEnd As Integer
        toWord.ActiveWindow.ActivePane.View.SeekView = Word.WdSeekView.wdSeekMainDocument
        Try
            ' Wanneer er een waarde gevonden wordt eerst kijken of deze rij in een tabel ligt 
            ' Wanneer de rij in een tabel ligt dan de hele rij kopieren en deze gaan vervangen
            For lnMon As Integer = 1 To toSubItems.Count
                Dim loCurrentMon
                loCurrentMon = toSubItems(lnMon)
                For Each prop As System.Reflection.PropertyInfo In loCurrentMon.GetType().GetProperties()
                    If prop.CanRead Then

                        With toWord.Selection
                            .SetRange(0, 0)

                            .Find.Text = "<#" + prop.Name + "#>"
                            .Find.MatchCase = False
                            .Find.MatchWholeWord = False
                            .Find.ClearFormatting()

                            If .Find.Execute() Then
                                ' de tag is gevonden, tekst vervangen en aan het eind van de selectie verder gaan met zoeken
                                ' kijken of de tag in een tabel ligt. 
                                ' Wanneer het veld in een tabel lligt moet de hele rij gekopieerd worden en vervangen moeten de cellen 1 voor 1 langs om ze te vervangen door een waarde
                                If toWord.Selection.Rows.Count > 0 Then
                                    ' De rij kopiëren en en voor elk monster de rij kopieren
                                    Dim loRow As Word.Row
                                    Dim loTable As Word.Table
                                    Dim lnStartRow As Integer = 0
                                    Dim lnEindRow As Integer = 0

                                    loTable = toWord.Selection.Tables(1)
                                    loRow = toWord.Selection.Rows(1)         ' de rij waarin de tag gevonden is
                                    lnStartRow = loRow.Index                ' De rij waar we moeten gaan beginnen met vervangen

                                    ' Voor elk monster en rij in gaan voegen
                                    loRow.Select()
                                    toWord.Selection.Copy()

                                    For lnTableMon As Integer = 1 To toSubItems.Count - 1

                                        toWord.Selection.Paste()
                                    Next

                                    ' voor alle monsters de waarden gaan invoegen
                                    For lnTableMon As Integer = 1 To toSubItems.Count
                                        ' Kijken of er monstervelden in de cel voorkomen
                                        loRow = loTable.Rows(lnStartRow + lnTableMon - 1)
                                        'Dim locell As Word.Cell
                                        Dim lctag As String = ""
                                        Dim lctext As String = ""

                                        For Each monprop As System.Reflection.PropertyInfo In toSubItems(lnTableMon).GetType().GetProperties()
                                            loRow.Select()

                                            If monprop.CanRead Then
                                                lctag = "<#" + monprop.Name + "#>"
                                                lctag = lctag.ToUpper
                                                toWord.Selection.Find.Text = lctag
                                                toWord.Selection.Find.ClearFormatting()
                                                Do While toWord.Selection.Find.Execute
                                                    toWord.Selection.Text = monprop.GetValue(toSubItems(lnTableMon))
                                                    loRow.Select()
                                                Loop
                                            End If
                                        Next


                                        'For Each locell In loRow.Cells
                                        '   For Each monprop As System.Reflection.PropertyInfo In toSubItems(lnTableMon).GetType().GetProperties()
                                        '       If monprop.CanRead Then
                                        '       lctag = "<#" + monprop.Name + "#>"
                                        '       lctag = lctag.ToUpper
                                        '           If locell.Range.Text.Contains(lctag) Then
                                        '             lctext = locell.Range.Text
                                        '             lctext = lctext.Replace(lctag, monprop.GetValue(toSubItems(lnTableMon)))
                                        '             locell.Range.Text = lctext
                                        '           End If
                                        '       End If
                                        '   Next
                                        'Next
                                    Next
                                Else
                                    lnRangeEnd = .Range.End
                                    .Text = prop.GetValue(toSubItems(lnMon))
                                    .SetRange(lnRangeEnd, lnRangeEnd)
                                End If
                            End If
                        End With
                    End If

                Next

            Next
        Catch
            ' geen actie er is iets fout gegaan. In template zal dit resulteren als dat er tags niet vervangen worden
        End Try



    End Sub




End Class


Public Class AsbestProject

    Private _PRJ_LAVSNR As String
    Public Property PRJ_LAVSNR() As String
        Get
            Return _PRJ_LAVSNR
        End Get
        Set(ByVal value As String)
            _PRJ_LAVSNR = value
        End Set
    End Property

    Private _PRJ_LOCTYPE As String
    Public Property PRJ_LOCTYPE() As String
        Get
            Return _PRJ_LOCTYPE
        End Get
        Set(ByVal value As String)
            _PRJ_LOCTYPE = value
        End Set
    End Property

    Private _PRJ_LOCADRES As String
    Public Property PRJ_LOCADRES() As String
        Get
            Return _PRJ_LOCADRES
        End Get
        Set(ByVal value As String)
            _PRJ_LOCADRES = value
        End Set
    End Property

    Private _PRJ_LOCPLAATS As String
    Public Property PRJ_LOCPLAATS() As String
        Get
            Return _PRJ_LOCPLAATS
        End Get
        Set(ByVal value As String)
            _PRJ_LOCPLAATS = value
        End Set
    End Property

    Private _PRJ_START_DDMMYY As String
    Public Property PRJ_START_DDMMYY() As String
        Get
            Return _PRJ_START_DDMMYY
        End Get
        Set(ByVal value As String)
            _PRJ_START_DDMMYY = value
        End Set
    End Property

    Private _PRJ_EIND_DDMMYY As String
    Public Property PRJ_EIND_DDMMYY() As String
        Get
            Return _PRJ_EIND_DDMMYY
        End Get
        Set(ByVal value As String)
            _PRJ_EIND_DDMMYY = value
        End Set
    End Property

    Private _PRJ_NEN2991 As String
    Public Property PRJ_NEN2991() As String
        Get
            Return _PRJ_NEN2991
        End Get
        Set(ByVal value As String)
            _PRJ_NEN2991 = value
        End Set
    End Property

    Public Sub New(ByVal prj_lavsnr As String, _
                    ByVal prj_loctype As String, _
                    ByVal prj_locadres As String, _
                    ByVal prj_start_ddmmyy As String, _
                    ByVal prj_eind_ddmmyy As String, _
                    ByVal prj_nen2991 As String)
        Me.PRJ_LAVSNR = prj_lavsnr
        Me.PRJ_LOCTYPE = prj_loctype
        Me.PRJ_LOCADRES = prj_locadres
        Me.PRJ_START_DDMMYY = prj_start_ddmmyy
        Me.PRJ_EIND_DDMMYY = prj_eind_ddmmyy
        Me.PRJ_NEN2991 = prj_nen2991
    End Sub
End Class
Public Class BouwkundigeEenheid
    Private _BEH_NAAM
    Public Property BEH_NAAM() As String
        Get
            Return _BEH_NAAM
        End Get
        Set(ByVal value As String)
            _BEH_NAAM = value
        End Set
    End Property

    Private _BEH_TOELICHTING
    Public Property BEH_TOELICHTING() As String
        Get
            Return _BEH_TOELICHTING
        End Get
        Set(ByVal value As String)
            _BEH_TOELICHTING = value
        End Set
    End Property

    Public Sub New(ByVal beh_naam As String, _
                ByVal beh_toelichting As String)
        Me.BEH_NAAM = beh_naam
        Me.BEH_TOELICHTING = beh_toelichting

    End Sub
End Class
Public Class AsbesthoudendeMateriaal
    Private _BAH_TYPE As String
    Public Property BAH_TYPE() As String
        Get
            Return _BAH_TYPE
        End Get
        Set(ByVal value As String)
            _BAH_TYPE = value
        End Set
    End Property

    Private _BAH_ASBESTHOUDEND As String
    Public Property BAH_ASBESTHOUDEND() As String
        Get
            Return _BAH_ASBESTHOUDEND
        End Get
        Set(ByVal value As String)
            _BAH_ASBESTHOUDEND = value
        End Set
    End Property

    Private _BAH_BINDING As String
    Public Property BAH_BINDING() As String
        Get
            Return _BAH_BINDING
        End Get
        Set(ByVal value As String)
            _BAH_BINDING = value
        End Set
    End Property

    Private _BAH_BEVESTIGINGMETHODE As String
    Public Property BAH_BEVESTIGINGMETHODE() As String
        Get
            Return _BAH_BEVESTIGINGMETHODE
        End Get
        Set(ByVal value As String)
            _BAH_BEVESTIGINGMETHODE = value
        End Set
    End Property

    Private _BAH_VERWIJDERINGMETHODE As String
    Public Property BAH_VERWIJDERINGMETHODE() As String
        Get
            Return _BAH_VERWIJDERINGMETHODE
        End Get
        Set(ByVal value As String)
            _BAH_VERWIJDERINGMETHODE = value
        End Set
    End Property

    Private _BAH_RISICOKLASSE As String
    Public Property BAH_RISICOKLASSE() As String
        Get
            Return _BAH_RISICOKLASSE
        End Get
        Set(ByVal value As String)
            _BAH_RISICOKLASSE = value
        End Set
    End Property

    Private _BAH_AANBEVOLENMAATREGEL As String
    Public Property BAH_AANBEVOLENMAATREGEL() As String
        Get
            Return _BAH_AANBEVOLENMAATREGEL
        End Get
        Set(ByVal value As String)
            _BAH_AANBEVOLENMAATREGEL = value
        End Set
    End Property

    Private _BAH_TOELICHTING As String
    Public Property BAH_TOELICHTING() As String
        Get
            Return _BAH_TOELICHTING
        End Get
        Set(ByVal value As String)
            _BAH_TOELICHTING = value
        End Set
    End Property

    Public Sub New(ByVal bah_type As String, _
            ByVal bah_asbesthoudend As String, _
            ByVal bah_binding As String, _
            ByVal bah_bevestigingmethode As String, _
            ByVal bah_verwijderingmethode As String, _
            ByVal bah_risicoklasse As String, _
            ByVal bah_aanbevolenmaatregel As String, _
            ByVal bah_toelichting As String)
        Me.BAH_TYPE = bah_type
        Me.BAH_ASBESTHOUDEND = bah_asbesthoudend
        Me.BAH_BINDING = bah_binding
        Me.BAH_BEVESTIGINGMETHODE = bah_bevestigingmethode
        Me.BAH_VERWIJDERINGMETHODE = bah_verwijderingmethode
        Me.BAH_RISICOKLASSE = bah_risicoklasse
        Me.BAH_AANBEVOLENMAATREGEL = bah_aanbevolenmaatregel
        Me.BAH_TOELICHTING = bah_toelichting
    End Sub
End Class
Public Class LocatieAhBron
    Private _BRL_TYPE As String
    Public Property BRL_TYPE() As String
        Get
            Return _BRL_TYPE
        End Get
        Set(ByVal value As String)
            _BRL_TYPE = value
        End Set
    End Property

    Private _BRL_NAAM As String
    Public Property BRL_NAAM() As String
        Get
            Return _BRL_NAAM
        End Get
        Set(ByVal value As String)
            _BRL_NAAM = value
        End Set
    End Property

    Private _BRL_BE As String
    Public Property BRL_BE() As String
        Get
            Return _BRL_BE
        End Get
        Set(ByVal value As String)
            _BRL_BE = value
        End Set
    End Property

    Private _BRL_CONDITIE As String
    Public Property BRL_CONDITIE() As String
        Get
            Return _BRL_CONDITIE
        End Get
        Set(ByVal value As String)
            _BRL_CONDITIE = value
        End Set
    End Property

    Private _BRL_AANTAL As String
    Public Property BRL_AANTAL() As String
        Get
            Return _BRL_AANTAL
        End Get
        Set(ByVal value As String)
            _BRL_AANTAL = value
        End Set
    End Property

    Private _BRL_HOEVEELHEID As String
    Public Property BRL_HOEVEELHEID() As String
        Get
            Return _BRL_HOEVEELHEID
        End Get
        Set(ByVal value As String)
            _BRL_HOEVEELHEID = value
        End Set
    End Property

    Private _BRL_TOELICHTING As String
    Public Property BRL_TOELICHTING() As String
        Get
            Return _BRL_TOELICHTING
        End Get
        Set(ByVal value As String)
            _BRL_TOELICHTING = value
        End Set
    End Property

    Public Sub New(ByVal brl_type As String, _
            ByVal brl_naam As String, _
            ByVal brl_be As String, _
            ByVal brl_conditie As String, _
            ByVal brl_aantal As String, _
            ByVal brl_hoeveelheid As String, _
            ByVal brl_toelichting As String)
        Me.BRL_TYPE = brl_type
        Me.BRL_NAAM = brl_naam
        Me.BRL_BE = brl_be
        Me.BRL_CONDITIE = brl_conditie
        Me.BRL_AANTAL = brl_aantal
        Me.BRL_HOEVEELHEID = brl_hoeveelheid
        Me.BRL_TOELICHTING = brl_toelichting
    End Sub
End Class
Public Class NietAhBron

    Private _BNH_TYPE As String
    Public Property BNH_TYPE() As String
        Get
            Return _BNH_TYPE
        End Get
        Set(ByVal value As String)
            _BNH_TYPE = value
        End Set
    End Property

    Private _BNH_ASBESTHOUDEND As String
    Public Property BNH_ASBESTHOUDEND() As String
        Get
            Return _BNH_ASBESTHOUDEND
        End Get
        Set(ByVal value As String)
            _BNH_ASBESTHOUDEND = value
        End Set
    End Property

    Private _BNH_BINDING As String
    Public Property BNH_BINDING() As String
        Get
            Return _BNH_BINDING
        End Get
        Set(ByVal value As String)
            _BNH_BINDING = value
        End Set
    End Property

    Private _BNH_BEVESTIGINGMETHODE As String
    Public Property BNH_BEVESTIGINGMETHODE() As String
        Get
            Return _BNH_BEVESTIGINGMETHODE
        End Get
        Set(ByVal value As String)
            _BNH_BEVESTIGINGMETHODE = value
        End Set
    End Property

    Private _BNH_VERWIJDERINGMETHODE As String
    Public Property BNH_VERWIJDERINGMETHODE() As String
        Get
            Return _BNH_VERWIJDERINGMETHODE
        End Get
        Set(ByVal value As String)
            _BNH_VERWIJDERINGMETHODE = value
        End Set
    End Property

    Private _BNH_RISICOKLASSE As String
    Public Property BNH_RISICOKLASSE() As String
        Get
            Return _BNH_RISICOKLASSE
        End Get
        Set(ByVal value As String)
            _BNH_RISICOKLASSE = value
        End Set
    End Property

    Private _BNH_AANBEVOLENMAATREGEL As String
    Public Property BNH_AANBEVOLENMAATREGEL() As String
        Get
            Return _BNH_AANBEVOLENMAATREGEL
        End Get
        Set(ByVal value As String)
            _BNH_AANBEVOLENMAATREGEL = value
        End Set
    End Property

    Private _BNH_TOELICHTING As String
    Public Property BNH_TOELICHTING() As String
        Get
            Return _BNH_TOELICHTING
        End Get
        Set(ByVal value As String)
            _BNH_TOELICHTING = value
        End Set
    End Property

    Public Sub New(ByVal bnh_type As String, _
            ByVal bnh_asbesthoudend As String, _
            ByVal bnh_binding As String, _
            ByVal bnh_bevestigingmethode As String, _
            ByVal bnh_verwijderingmethode As String, _
            ByVal bnh_risicoklasse As String, _
            ByVal bnh_aanbevolenmaatregel As String, _
            ByVal bnh_toelichting As String)
        Me.BNH_TYPE = bnh_type
        Me.BNH_ASBESTHOUDEND = bnh_asbesthoudend
        Me.BNH_BINDING = bnh_binding
        Me.BNH_BEVESTIGINGMETHODE = bnh_bevestigingmethode
        Me.BNH_VERWIJDERINGMETHODE = bnh_verwijderingmethode
        Me.BNH_RISICOKLASSE = bnh_risicoklasse
        Me.BNH_AANBEVOLENMAATREGEL = bnh_aanbevolenmaatregel
        Me.BNH_TOELICHTING = bnh_toelichting
    End Sub


End Class
Public Class AsbestDocument
    Private _DOC_TYPE As String
    Public Property DOC_TYPE() As String
        Get
            Return _DOC_TYPE
        End Get
        Set(ByVal value As String)
            _DOC_TYPE = value
        End Set
    End Property

    Private _DOC_NAAM As String
    Public Property DOC_NAAM() As String
        Get
            Return _DOC_NAAM
        End Get
        Set(ByVal value As String)
            _DOC_NAAM = value
        End Set
    End Property

    Public Sub New(ByVal doc_type As String, _
            ByVal doc_naam As String)
        Me.DOC_TYPE = doc_type
        Me.DOC_NAAM = doc_naam
    End Sub

End Class
Public Class Monster
    Private _MON_CODE As String
    Public Property MON_CODE() As String
        Get
            Return _MON_CODE
        End Get
        Set(ByVal value As String)
            _MON_CODE = value
        End Set
    End Property

    Private _MON_BRON As String
    Public Property MON_BRON() As String
        Get
            Return _MON_BRON
        End Get
        Set(ByVal value As String)
            _MON_BRON = value
        End Set
    End Property

    Private _MON_PERCASBEST As String
    Public Property MON_PERCASBEST() As String
        Get
            Return _MON_PERCASBEST
        End Get
        Set(ByVal value As String)
            _MON_PERCASBEST = value
        End Set
    End Property

    Private _MON_TOELICHTING As String
    Public Property MON_TOELICHTING() As String
        Get
            Return _MON_TOELICHTING
        End Get
        Set(ByVal value As String)
            _MON_TOELICHTING = value
        End Set
    End Property

    Private _MON_LABANALYSENR As String
    Public Property MON_LABANALYSENR() As String
        Get
            Return _MON_LABANALYSENR
        End Get
        Set(ByVal value As String)
            _MON_LABANALYSENR = value
        End Set
    End Property

    Public Sub New(ByVal mon_code As String, _
            ByVal mon_bron As String, _
            ByVal mon_percasbest As String, _
            ByVal mon_toelichting As String, _
            ByVal mon_labanalysenr As String)
        Me.MON_CODE = mon_code
        Me.MON_BRON = mon_bron
        Me.MON_PERCASBEST = mon_percasbest
        Me.MON_TOELICHTING = mon_toelichting
        Me.MON_LABANALYSENR = mon_labanalysenr
    End Sub


End Class

Public Class EnumTeksten
    Public Sub Enum_AARD_MATERIAAL(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("NVT", "N.v.t.")
        aEnumTeksten.Add("HECHTGEBONDEN", "Hechtgebonden")
        aEnumTeksten.Add("NIET_HECHTGEBONDEN", "Niet hechtgebonden")
    End Sub
    Public Sub Enum_ASBEST_ADVIES(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("NVT", "N.v.t.")
        aEnumTeksten.Add("NEN_2991_ONDERZOEK", "NEN 2991 onderzoek")
        aEnumTeksten.Add("TYPE_B_INVENTARISATIE", "Type B inventarisatie")
        aEnumTeksten.Add("NEN_2991_EN_TYPE_B_INVENTARISATIE", "NEN2991 en Type B inventarisatie")
    End Sub
    Public Sub Enum_ASBEST_CONDITIE(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("NIET_VERWEERD", "Niet verweerd")
        aEnumTeksten.Add("VERWEERD", "Verweerd")
        aEnumTeksten.Add("STERK_VERWEERD", "Sterk verweerd")
    End Sub
    Public Sub Enum_ASBEST_EENHEID(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("M", "M")
        aEnumTeksten.Add("M2", "M2")
        aEnumTeksten.Add("M3", "M3")
        aEnumTeksten.Add("STUKS", "Stuks")
    End Sub
    Public Sub Enum_ASBEST_EENHEID_VOLUME(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("ML", "milliliter")
        aEnumTeksten.Add("L", "liter")
        aEnumTeksten.Add("M3", "M3")
        aEnumTeksten.Add("STUKS", "m3")
    End Sub
    Public Sub Enum_ASBEST_HOEVEELHEID(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("BEREKENDE_HOEVEELHEID", "Geschatte hoeveelheid")
        aEnumTeksten.Add("GEMETEN_HOEVEELHEID", "Gemeten hoeveelheid")
        aEnumTeksten.Add("GESCHATTE_HOEVEELHEID", "Geschatte hoeveelheid")
    End Sub
    Public Sub Enum_ASBEST_MAATREGEL(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("NVT", "N.v.t.")
        aEnumTeksten.Add("DIRECTE_SANERING_NOODZAKELIJK", "Directe sanering noodzakelijk")
        aEnumTeksten.Add("OPSTELLEN_BEHEERSPLAN_SANERING_OP_TERMIJN_NOODZAKELIJK", "Opstellen beheersplan sanering op termijn noodzakelijk")
    End Sub
    Public Sub Enum_ASBEST_VERWIJDERING_KEUZE(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("GEEN_ACTIE_ONDERNEMEN", "Geen actie ondernemen")
        aEnumTeksten.Add("ASBEST_VERWIJDEREN", "Asbest verwijderen")
    End Sub
    Public Sub Enum_ASBEST_VERWIJDERING_METHODE(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("NVT", "N.v.t.")
        aEnumTeksten.Add("BUITENSANERING", "Buitensanering")
        aEnumTeksten.Add("CONTAINMENT", "Containment")
        aEnumTeksten.Add("DIRECT_VERPAKKEN", "Direct verpakken")
    End Sub
    Public Sub Enum_ASBESTHOUDEND(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("JA", "Ja")
        aEnumTeksten.Add("INTECHNIUM", "JA (Installatie Intechnium),")
        aEnumTeksten.Add("NEE", "Nee")
        aEnumTeksten.Add("VERDACHT", "Verdacht")
    End Sub
    Public Sub Enum_DOCUMENT(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("FOTO_BRON", "Foto bron")
        aEnumTeksten.Add("INVENTARISATIERAPPORT", "Inventarisatierapport")
        aEnumTeksten.Add("NEN2991RAPPORT", "EN2991 rapport")
        aEnumTeksten.Add("PLATTEGROND", "Plattegrond")
        aEnumTeksten.Add("VRIJGAVECERTIFICAAT", "Vrijgavecertificaat")
        aEnumTeksten.Add("AFKEURING", "Afkeuringscertificaat")
        aEnumTeksten.Add("STORTBON", "Stortbon")
        aEnumTeksten.Add("GELEIDEBILJET", "Geleidebiljet")
        aEnumTeksten.Add("OVERIGE", "Overige")
    End Sub
    Public Sub Enum_INVENTARISATIE(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("GEDEELTELIJKE_INVENTARISATIE", "Gedeeltelijke inventarisatie")
        aEnumTeksten.Add("VOLLEDIGE_INVENTARISATIE", "Volledige inventarisatie")
    End Sub
    Public Sub Enum_LOCATIE(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("AGRARISCHE_BEDRIJFSGEBOUWEN", "Agrarische bedrijfsgebouwen")
        aEnumTeksten.Add("FABRIEK", "Fabriek")
        aEnumTeksten.Add("FLATS", "Flat(s)")
        aEnumTeksten.Add("KANTOOR", "Kantoor")
        aEnumTeksten.Add("OVERIGE", "Overige")
        aEnumTeksten.Add("SCHOOL", "School")
        aEnumTeksten.Add("WONING", "Woning")
    End Sub
    Public Sub Enum_MELDING(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("INVENTARISATIE", "Inventarisatie")
        aEnumTeksten.Add("VERWIJDERING", "Verwijdering")
    End Sub
    Public Sub Enum_ONDERZOEK(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("KLEEFMONSTER", "Kleefmonster")
        aEnumTeksten.Add("MATERIAALMONSTER", "Materiaalmonster")
    End Sub
    Public Sub Enum_NEN2991ONDERZOEK(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("KLEEFMONSTER", "Kleefmonster")
        aEnumTeksten.Add("MATERIAALMONSTER", "Materiaalmonster")
    End Sub
    Public Sub Enum_ONDERZOEK_BEVESTIGINGS_METHODE(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("NVT", "N.v.t.")
        aEnumTeksten.Add("GEHANGEN", "Gehangen")
        aEnumTeksten.Add("GEKIT", "Gekit")
        aEnumTeksten.Add("GEKLEMD", "Geklemd")
        aEnumTeksten.Add("GEKLEMD_TUSSEN_FLENZEN_PAKKING", "Geklemd tussen flenzen (pakkingen)")
        aEnumTeksten.Add("GELIJMD", "Gelijmd")
        aEnumTeksten.Add("GEMETSELD", "Gemetseld")
        aEnumTeksten.Add("GENIET", "Geniet")
        aEnumTeksten.Add("GESCHILDERD", "Geschilderd")
        aEnumTeksten.Add("GESCHROEFD", "Geschroefd")
        aEnumTeksten.Add("GESMEERD", "Gesmeerd")
        aEnumTeksten.Add("GESPIJKERD", "Gespijkerd")
        aEnumTeksten.Add("GESPOTEN", "Gespoten")
        aEnumTeksten.Add("GESTORT", "Gestort")
        aEnumTeksten.Add("GESTUCT", "Gestuct")
        aEnumTeksten.Add("GEWIKKELD", "Gewikkeld")
        aEnumTeksten.Add("LOS", "Los")
        aEnumTeksten.Add("MET_POPNAGELS", "Met popnagels")
        aEnumTeksten.Add("ONBEKEND", "Onbekend")
        aEnumTeksten.Add("VERWERKT", "Verwerkt")
    End Sub
    Public Sub Enum_OPDRACHT_TYPE(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("COORDINATIE", "Coordinatie")
        aEnumTeksten.Add("INVENTARISEERDER", "Inventarisatie (Type A)")
        aEnumTeksten.Add("INVENTARISEERDER_TYPEB", "Inventarisatie (Type B)")
        aEnumTeksten.Add("INVENTARISEERDER_NEN2991", "NEN 2991 Onderzoek")
        aEnumTeksten.Add("VERWIJDERAAR", "Inventarisatie")
        aEnumTeksten.Add("EINDMETING", "Eindmeting")
        aEnumTeksten.Add("STORT", "Stort")
    End Sub
    Public Sub Enum_PERCENTAGE(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("GEEN_ASBEST", "-")
        aEnumTeksten.Add("NULCOMMAEEN_TOT_TWEEPROCENT", "0,1-2%")
        aEnumTeksten.Add("TWEE_TOT_VIJFPROCENT", "2-5%")
        aEnumTeksten.Add("VIJF_TOT_TIENPROCENT", "5-10%")
        aEnumTeksten.Add("TIEN_TOT_VIJFTIENPROCENT", "10-15%")
        aEnumTeksten.Add("VIJFTIEN_TOT_DERTIGPROCENT", "15-30%")
        aEnumTeksten.Add("DERTIG_TOT_ZESTIGPROCENT", "30-60%")
        aEnumTeksten.Add("GROTER_DAN_ZESTIGPROCENT", "> 60%")
    End Sub
    Public Sub Enum_SMA_RISICO_KLASSE(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("NVT", "N.v.t.")
        aEnumTeksten.Add("RISICOKLASSE_1", "Risicoklasse 1")
        aEnumTeksten.Add("RISICOKLASSE_2", "Risicoklasse 2")
        aEnumTeksten.Add("RISICOKLASSE_3", "Risicoklasse 3")
    End Sub
    Public Sub Enum_TITEL(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("MENEER", "Meneer")
        aEnumTeksten.Add("MEVROUW", "Mevrouw")
    End Sub
    Public Sub Enum_VERVOLG_ONDERZOEKS_KEUZE(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("GEEN_ACTIE_ONDERNEMEN", "Geen actie ondernemen")
        aEnumTeksten.Add("VERVOLGONDERZOEK_UITVOEREN", "Vervolgonderzoek uitvoeren")
    End Sub
    Public Sub Enum_VERWIJDERING_RESULTAAT(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("DUURZAAM_VERPAKT", "Duurzaam verpakt")
        aEnumTeksten.Add("VERWIJDERD", "Verwijderd")
        aEnumTeksten.Add("NIET_VERWIJDERD", "Niet verwijderd")
        aEnumTeksten.Add("DEELS_VERWIJDERD", "Deels verwijderd")
    End Sub
    Public Sub Enum_VEZELS_INDICATOR(ByRef aEnumTeksten As Dictionary(Of String, String))
        ' Waardes toevoegen
        aEnumTeksten.Add("GEEN", "-")
        aEnumTeksten.Add("SPOREN", "+/-")
        aEnumTeksten.Add("DUIDELIJK", "+")
        aEnumTeksten.Add("VEEL", "++")
    End Sub

End Class

